# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from . import utilities, tables

class CloudInitConfig(pulumi.CustomResource):
    base64_encode: pulumi.Output[bool]
    gzip: pulumi.Output[bool]
    parts: pulumi.Output[list]
    rendered: pulumi.Output[str]
    def __init__(__self__, resource_name, opts=None, base64_encode=None, gzip=None, parts=None, __props__=None, __name__=None, __opts__=None):
        """
        Create a CloudInitConfig resource with the given unique name, props, and options.
        
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        
        The **parts** object supports the following:
        
          * `content` (`pulumi.Input[str]`)
          * `contentType` (`pulumi.Input[str]`)
          * `filename` (`pulumi.Input[str]`)
          * `mergeType` (`pulumi.Input[str]`)
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['base64_encode'] = base64_encode
            __props__['gzip'] = gzip
            if parts is None:
                raise TypeError("Missing required property 'parts'")
            __props__['parts'] = parts
            __props__['rendered'] = None
        super(CloudInitConfig, __self__).__init__(
            'terraform-template:index/cloudInitConfig:CloudInitConfig',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, base64_encode=None, gzip=None, parts=None, rendered=None):
        """
        Get an existing CloudInitConfig resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.
        
        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        
        The **parts** object supports the following:
        
          * `content` (`pulumi.Input[str]`)
          * `contentType` (`pulumi.Input[str]`)
          * `filename` (`pulumi.Input[str]`)
          * `mergeType` (`pulumi.Input[str]`)
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()
        __props__["base64_encode"] = base64_encode
        __props__["gzip"] = gzip
        __props__["parts"] = parts
        __props__["rendered"] = rendered
        return CloudInitConfig(resource_name, opts=opts, __props__=__props__)
    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

